﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TwitterAtomFeedLibrary;

namespace BlogPostTwistori
{
  public partial class ItemDisplayControl : UserControl
  {
    public event EventHandler ControlReady;

    public ItemDisplayControl()
    {
      InitializeComponent();
    }
    public void Explode()
    {
      textControl.Explode();
    }
    public void Implode()
    {
      textControl.Implode();
    }
    void FireControlReady()
    {
      if (ControlReady != null)
      {
        ControlReady(this, null);
      }
    }
    private void OnImageDataContextChanged(object sender, DependencyPropertyChangedEventArgs e)
    {
      AtomFeedItem feedItem = (AtomFeedItem)e.NewValue;

      // The item may not have an image, in which case...we are done.
      if (!feedItem.HasImage)
      {
        FireControlReady();
      }
      else if (!feedItem.HasImageNeedingDownload)
      {
        // Some images are packed (i.e. pack://) into the executable. No
        // need to download them.
        imageAuthor.Source = new BitmapImage(feedItem.AuthorImageUri);
        FireControlReady();
      }
      else
      {
        BitmapImage bi = new BitmapImage();
        bi.BeginInit();
        bi.UriSource = feedItem.AuthorImageUri;
        bi.DownloadCompleted += (s, args) =>
          {
            imageAuthor.Source = bi;
            FireControlReady();
          };
        bi.DownloadFailed += (s, args) =>
          {
            FireControlReady();
          };
        bi.EndInit();
      }
    }
  }
}
