﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;

namespace BlogPostTwistori
{
  class TransformFactors
  {
    static TransformFactors()
    {
      random = new Random((int)DateTime.Now.Ticks);
    }
    public double Scale { get; set; }
    public double Rotation { get; set; }
    public double TranslateX { get; set; }
    public double TranslateY { get; set; }

    public void Randomise()
    {
      Scale = (random.NextDouble() * MAX_SCALE);
      TranslateX = ((random.NextDouble() * MAX_TRANSLATE * 2.0) - MAX_TRANSLATE);
      TranslateY = ((random.NextDouble() * MAX_TRANSLATE * 2.0) - MAX_TRANSLATE);
      Rotation = ((random.NextDouble() * MAX_ROTATE * 2.0) - MAX_ROTATE);
    }
    public void ApplyTo(ScaleTransform scale)
    {
      scale.ScaleX = scale.ScaleY = Scale;
    }
    public void ApplyTo(TranslateTransform translate)
    {
      translate.X = TranslateX;
      translate.Y = TranslateY;
    }
    public void ApplyTo(RotateTransform rotate)
    {
      rotate.Angle = Rotation;
    }
    const double MAX_SCALE = 5.0;
    const double MAX_TRANSLATE = 96.0;
    const double MAX_ROTATE = 90.0;
    static Random random;
  }
}