﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TwitterAtomFeedLibrary;
using System.Windows.Media.Animation;

namespace BlogPostTwistori
{
  public partial class Window1 : Window
  {
    public Window1()
    {
      InitializeComponent();

      this.Loaded += OnLoaded;
    }
    void OnItemDisplayReady(object sender, EventArgs args)
    {
      Dispatcher.BeginInvoke(new Action(() =>
        {
          ShowItemDisplayControl();
        }));
    }
    void ShowItemDisplayControl()
    {
      displayControl.Visibility = Visibility.Visible;
      SbRipple.Begin();
      displayControl.Implode();
    }
    void HideItemDisplayControl()
    {
      displayControl.Visibility = Visibility.Hidden;      
    }
    Storyboard SbRipple
    {
      get
      {
        return (mainGrid.FindResource("sbRipple") as Storyboard);
      }
    }
    void OnLoaded(object sender, RoutedEventArgs e)
    {
      // TODO: Handle exceptions from config loading?
      SearchTermsConfiguration config = SearchTermsConfiguration.LoadFromConfig();

      feedManager = new AtomFeedManager(config, new TimeSpan(0, 0, 5));

      feedManager.FeedItemAvailable += OnFeedItemAvailable;
      feedManager.FeedItemUnavailable += OnFeedItemUnavailable;

      listSearchTerms.DataContext = config;
    }
    void OnFeedItemAvailable(object sender, AtomFeedItemAvailableEventArgs args)
    {
      Dispatcher.BeginInvoke(new Action(() =>
        {
          HideItemDisplayControl();
          displayControl.DataContext = args.FeedItem;
          listSearchTerms.SelectedItem = args.SearchTerm;
          listSearchTerms.ScrollIntoView(args.SearchTerm);
        }));
    }
    void OnFeedItemUnavailable(object sender, AtomFeedItemUnavailableEventArgs args)
    {
      Dispatcher.BeginInvoke(new Action(() =>
      {
        HideItemDisplayControl();
        displayControl.DataContext = new AtomFeedItem()
        {
          Author = "none",
          AuthorImageUri = new Uri("pack://application:,,,/question.jpg"),
          Title = string.Format("No activity for {0:0} seconds, check your options",
            args.UnavailableTime.TotalSeconds),
          PublishedDate = DateTime.Now
        };
      }));
    }
    void OnExit(object sender, ExecutedRoutedEventArgs e)
    {
      Application.Current.Shutdown();
    }
    AtomFeedManager feedManager;
  }
}
